import numpy as np
import pygame
from pygame.locals import *

# Tip: Be careful about mixing integers and floats!
class Avatar(object):

  def __init__(self, name, surface, position, speed):
    self.name = name
    self.surface = surface
    self.position = np.array(position)
    self.speed = speed
    
  def update(self, target, time):

    if not np.array_equal(target, [0.0, 0.0]):
      target = target / np.sqrt(np.dot(target, target))
      target = target * self.speed
                                  
    self.position = self.position + target * time
        
if __name__ == '__main__':
  boy_image = pygame.image.load('Character Boy.png')
  a = Avatar("Titus", boy_image, (0.0,0.0), 300)
