import pygame
from pygame.locals import *

import pathfind

import numpy as np
from collections import deque

from avatar import *

# This lets you switch levels quickly.
level = pathfind.level1

pygame.init()

screen = pygame.display.set_mode((640,480), 0, 32)

# To easily construct bounding boxes, images are now going to be rectangles.
boy_image = pygame.Surface((25,25))
boy_image.fill((255,255,255))
                    
girl_image = pygame.Surface((25,25))
girl_image.fill((255,255,255))

# Create avatar objects.
boy = Avatar("Boy", boy_image, (50.0,50.0), 200.0)
girl = Avatar("Girl", girl_image, (300.0, 300.0), 50.0)

clock = pygame.time.Clock()

# TODO: Load an array of tiles to translate the level to a block.
tiles = {
  
}

# The height and width of each tile.
TILE_WIDTH = 100
TILE_HEIGHT = 100

# Low-level seek movement; ai should be an avatar object.
def seek(ai, to, time_passed):
  target = to - ai.position
  ai.update(target, time_passed)

def tilePositionToPixel(tile):

  # TODO: Need to replace this with a calculation.
  return (50, 50)

# TODO: Need to fill out this function.
def findNext(level, enemy, player):

    # Figure out which tile you and your enemy are by
    # unpacking the player.    

    # Call BFS function.
    
    # Return pixel position of tile.
    return (50, 50)
  
def drawBoard(level, tiles, screen):
  
  width = len(level) * TILE_WIDTH
  height = len(level[0]) * TILE_HEIGHT
 
  for x in range(len(level[0])):
    for y in range(len(level)):

      where = (x * TILE_WIDTH, y * TILE_HEIGHT, TILE_WIDTH, TILE_HEIGHT)

      # Get allows for a default argument.
      color = tiles.get(level[y][x], (0,0,0))

      if level[y][x] == '#':
        pygame.draw.rect(screen, color, Rect(where))
      else:
        pygame.draw.rect(screen, color, Rect(where), 1)

while True:

  time_passed = clock.tick(30)
  time_passed_seconds = time_passed / 1000.0

  for event in pygame.event.get():
    
    if event.type == QUIT:
      exit()

  pressed_keys = pygame.key.get_pressed()

  target = np.array([0.0,0.0])

  # Handle keyboard presses.
  if pressed_keys[K_LEFT]:
    target += np.array([-1.0,0.0])
  if pressed_keys[K_RIGHT]:
    target += np.array([1.0,0.0])
  if pressed_keys[K_UP]:
    target += np.array([0.0,-1.0])
  if pressed_keys[K_DOWN]:
    target += np.array([0.0,1.0])

  screen.fill((0,0,0))

  boy.update(target, time_passed_seconds)
  drawBoard(level, tiles, screen)

  # TODO: Needs to be repositioned.
  screen.blit(girl.surface, girl.position)
  screen.blit(boy.surface, boy.position)  
  
  pygame.display.update()

  find_next = findNext(level, girl, boy)

  if find_next is not None:
    seek(girl, find_next, time_passed_seconds)

# Wrap up.
pygame.quit()
